VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   Caption         =   "Autonumber Hard Reset"
   ClientHeight    =   1800
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6375
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   1800
   ScaleWidth      =   6375
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame fraDBType 
      Caption         =   "Database Type"
      Height          =   975
      Left            =   4320
      TabIndex        =   5
      Top             =   120
      Width           =   1935
      Begin VB.OptionButton optDBType 
         Caption         =   "MS Access 97"
         Height          =   255
         Index           =   1
         Left            =   120
         TabIndex        =   3
         Top             =   600
         Width           =   1695
      End
      Begin VB.OptionButton optDBType 
         Caption         =   "MS Access 2000"
         Height          =   255
         Index           =   0
         Left            =   120
         TabIndex        =   2
         Top             =   240
         Value           =   -1  'True
         Width           =   1695
      End
   End
   Begin VB.CommandButton cmdBrowse 
      Caption         =   "..."
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   6.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   3960
      TabIndex        =   1
      Top             =   120
      Width           =   255
   End
   Begin VB.TextBox txtSourceFile 
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   1320
      TabIndex        =   0
      Top             =   120
      Width           =   2535
   End
   Begin MSComctlLib.StatusBar Status 
      Align           =   2  'Align Bottom
      Height          =   255
      Left            =   0
      TabIndex        =   7
      Top             =   1545
      Width           =   6375
      _ExtentX        =   11245
      _ExtentY        =   450
      Style           =   1
      _Version        =   393216
      BeginProperty Panels {8E3867A5-8586-11D1-B16A-00C0F0283628} 
         NumPanels       =   1
         BeginProperty Panel1 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
         EndProperty
      EndProperty
   End
   Begin MSComctlLib.ProgressBar Progress 
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   1200
      Width           =   6135
      _ExtentX        =   10821
      _ExtentY        =   450
      _Version        =   393216
      Appearance      =   1
      Scrolling       =   1
   End
   Begin VB.CommandButton cmdReset 
      Caption         =   "Reset Autonumbers for All Tables"
      Height          =   495
      Left            =   120
      TabIndex        =   4
      Top             =   600
      Width           =   4095
   End
   Begin MSComDlg.CommonDialog cmnDialog 
      Left            =   3840
      Top             =   0
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Label lblSource 
      Caption         =   "Source File:"
      Height          =   255
      Left            =   240
      TabIndex        =   8
      Top             =   120
      Width           =   1095
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub cmdBrowse_Click()
  On Error GoTo Err_cmdBrowse_Click

  ' allow for an error when user cancels
  cmnDialog.CancelError = True
  ' set the file filter
  cmnDialog.Filter = "Microsoft Access Database (*.mdb)|*.mdb"
  ' open the dialog showing the "Open" dialog
  cmnDialog.ShowOpen
  ' set the textbox field equal to the user's selection
  txtSourceFile.Text = cmnDialog.FileName

Err_cmdBrowse_Click:
  ' if error occurred, exit function (most likely due to user cancel)
End Sub

Private Sub cmdReset_Click()
  On Error GoTo Err_Reset
  Dim db    As ADODB.Connection     ' connection object
  Dim rst   As New ADODB.Recordset  ' recordset object
  Dim MyDB  As DBType

  ' check to make sure the user-entered fields are valid
  If CheckValidFields() = False Then Exit Sub

  ' set the database type
  If optDBType(0).Value = True Then
    MyDB = dbAccess2000
  ElseIf optDBType(1).Value = True Then
    MyDB = dbAccess97
  End If

  ' update the screen's mousepointer
  Screen.MousePointer = vbHourglass
  ' open the database at the specified location
  Set db = OpenDatabase(MyDB, txtSourceFile.Text)

  ' initialize the recordset's active connection
  Set rst.ActiveConnection = db
  ' open table schema and store data in rst object
  Set rst = db.OpenSchema(adSchemaTables, Array(Empty, Empty, Empty, "TABLE"))

  ' move to the last record and increment backwards to count the number of records
  ' we do this because the .recordcount more often than not has problems...
  rst.MoveLast
  Progress.Max = 1
  Do Until rst.BOF
    Progress.Max = Progress.Max + 1
    rst.MovePrevious
  Loop
  Progress.Max = Progress.Max - 1
  rst.MoveFirst

  ' initialize the progress bar's value
  Progress.Value = 0

  ' loop to end of the table name recordset
  Do Until rst.EOF
    ' reset the seed for this particular table,
    ' update the progress bar, and move to next record
    ResetSeed db, rst.Fields("TABLE_NAME")
    Progress.Value = Progress.Value + 1
    rst.MoveNext
  Loop

  ' close the recordset and connection, and free up the memory
  rst.Close
  Set rst = Nothing
  CloseDatabase db
  Set db = Nothing

  ' update the status bar and compact and repair the database
  Status.SimpleText = "Compacting and Repairing..."
  CompactRepair txtSourceFile.Text

  ' update the status bar text and screen's mousepointer
  Status.SimpleText = "Process Completed Successfully!"
  Screen.MousePointer = vbDefault
  Exit Sub

Err_Reset:
  ' error handler (update the screen mousepointer and notify the user of error)
  Screen.MousePointer = vbDefault
  ' if the user wants to retry, then resume from where the error occurred
  If MsgBox("There has been a critical error!" & Chr(13) & _
    "Error " & Err.Number & ": " & Err.Description, vbCritical + vbRetryCancel, "Critical Error") = vbRetry Then
    Screen.MousePointer = vbHourglass
    DoEvents
    Resume
  End If
  ' free the memory
  Set db = Nothing
  Set rst = Nothing
End Sub

Private Sub Form_Load()
  ' load the small icon in the icon file
  Me.Icon = LoadPicture(App.Path & "\Access.ico", vbLPSmall, vbLPColor, 16, 16)
End Sub

Private Sub txtSourceFile_GotFocus()
  ' select all on gotfocus
  txtSourceFile.SelStart = 0
  txtSourceFile.SelLength = Len(txtSourceFile.Text)
End Sub

Private Function CheckValidFields() As Boolean
  ' checks the validity of user-entered fields
  CheckValidFields = False
  ' ensures a valid file name has been entered
  If Len(txtSourceFile.Text) = 0 Or InStr(1, txtSourceFile.Text, ".", 0) = 0 Then
    MsgBox "Please enter a valid file to use!", vbOKOnly + vbExclamation, "Error"
    txtSourceFile.SetFocus
    Exit Function
  End If
  ' ensures that a database type has been selected
  If optDBType(0).Value = False And optDBType(1).Value = False Then
    MsgBox "Please select a Database Type!", vbOKOnly + vbExclamation, "Error"
    optDBType(0).SetFocus
    Exit Function
  End If

  CheckValidFields = True
End Function
